//**************************************************************************
//   Windows
// service_manager.js
//**************************************************************************

//    
var WSO = new ActiveXObject("Scripting.WindowSystemObject");
var FSO = new ActiveXObject("Scripting.FileSystemObject");
var WshShell = new ActiveXObject("WScript.Shell");
var FSO = new ActiveXObject("Scripting.FileSystemObject");
var objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2");

var list_view_obj, shared_data_array = [];
var Button_Update, Button_Stop, Button_Run, Button_Pause;
var Button_Continue, Button_Auto, Button_Manual, Button_Disable;

var wbemFlagForwardOnly = 0x20; //32
var wbemFlagReturnImmediately = 0x10; //16

var vbOKCancel = 1;
var vbOK = 1;
var vbInformation = 64;
var vbCancel = 2;

//    
var temp_file = WshShell.ExpandEnvironmentStrings("%TEMP%") + "\\" + FSO.GetTempName();

// *************************   ************************************************
var f = WSO.CreateForm(0, 0, 0, 0, WSO.Translate("WS_CONTROLBOX | WS_MINIMIZEBOX"));
with(f){
	Text = "  Windows";
	ClientWidth = 700;
	ClientHeight = 600;
	CenterControl();
}

//******************************************************************************
//                       
//*****************************************************************************
var b = f.Bevel(510, 90, 150,170, WSO.Translate("BS_LOWERED"))
b.Color = 0xFFFFE0
var c = f.Bevel(510, 300, 150,130, WSO.Translate("BS_LOWERED"))
c.Color = 0xFFFFE
//*******************************************************************************

//********************************************************************************
//                   
//********************************************************************************

//   
Button_Update = f.CreateButton(530,10,100,25," ");
Button_Update.OnClick = ServiceUpdate;

t = f.CreateHyperLink(530,40,250,25,"www.scriptcoding.ru");

//     
Button_Stop = f.CreateButton(530,100,100,25,"");
Button_Stop.OnClick = ServiceStop;

//     
Button_Run= f.CreateButton(530,130,100,25,"");
Button_Run.OnClick = ServiceRun;

//     
Button_Pause = f.CreateButton(530,160,100,25,"");
Button_Pause.OnClick = ServicePause;

//     
Button_Continue = f.CreateButton(530,190,100,25,"");
Button_Continue.OnClick = ServiceContinue;

//********************************************************************************
//********************************************************************************

//     
Button_Auto = f.CreateButton(520,310,135,25," ");
Button_Auto.OnClick = ServiceAuto;

//    
Button_Manual = f.CreateButton(520,340,130,25," ");
Button_Manual.OnClick = ServiceManual;

// 
Button_Disable = f.CreateButton(520,370,130,25,"");
Button_Disable.OnClick = ServiceDisable;

//********************************************************************************


//      
function fill_data_array(data_array){
var objItem, colItems
   data_array.length = 0; // !!!!!
    
	//   
	colItems = new Enumerator(objWMIService.ExecQuery("Select * From Win32_Service"));
	
	
	//   
	for (; !colItems.atEnd(); colItems.moveNext()){
		objItem = colItems.item();
		
		//    
		data_array.push({
			Name: objItem.Name,
			DisplayName: objItem.DisplayName,
			State: objItem.State,
			PathName: objItem.PathName,
			StartMode: objItem.StartMode
		});
	}
};
//***************************************************************


//   
var def_columns = [
	{ name: "",      width: 100, type: 1, 
		set_data: function(item, data) { item.Text = data.Name;        }},
			
	{ name: "",      width:  100, type: 1, 
		set_data: function(item, data) { item.SubItems(0) = data.DisplayName;  } },
									
	{ name: "",      width:  80, type: 1, 
		set_data: function(item, data) { item.SubItems(1) = data.State;  } },
			
	{ name: "",   width: 130, type: 1, 
		set_data: function(item, data) { item.SubItems(2) = data.PathName; } },
			
	{ name: "",     width: 100, type: 1, 
		set_data: function(item, data) { item.SubItems(3) = data.StartMode; } }
];

//    
function CreateListView(){
	//  ListView
	list_view_obj = f.CreateListView( 0, 0, 500, 600,WSO.Translate("LVS_REPORT | LVS_OWNERDATA | LVS_SHOWSELALWAYS"));
    //  ListView
	list_view_obj.GridLines = true;
	list_view_obj.RowSelect = true;
	list_view_obj.ReadOnly = false;
	list_view_obj.ItemIndex = 1;
	
	/*--------------------------------------------------------------*/
	//             
	/*--------------------------------------------------------------*/
   
	for(var ix = 0; ix < def_columns.length; ++ix){
		var def_col = def_columns[ix];
		var column = list_view_obj.Columns.Add(def_col.name, def_col.width);
		column.DataType = def_col.type;
	}
	
    /*--------------------------------------------------------------*/
	//                  
	/*--------------------------------------------------------------*/
	list_view_obj.OnData = function (sender, item){
		//
		sender.BeginUpdate();  
		//  
		//  shared_data_array       
		var data = shared_data_array[item.Index];
		
		//    
		for(var ix = 0; ix < def_columns.length; ++ix){
			def_columns[ix].set_data(item, data);
		}
		
		//
		sender.EndUpdate();
	};
	/* callbacks *************************************************** */
	
	//     
	fill_data_array(shared_data_array);
	//  
	list_view_obj.Count = shared_data_array.length; 
};

//   
function ServiceUpdate(){
	//   
	list_view_obj.Clear();
	
	fill_data_array(shared_data_array);
	list_view_obj.Count = shared_data_array.length; // !!!!!
};

//-------------------------------------------------------------------------------
//                
//-------------------------------------------------------------------------------

//      
function ServiceStop(Sender){	
var cur_service_name, objStopService
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		objStopService = objWMIService.Get("Win32_Service.Name=\'" + cur_service_name + "\'");
		ReturnCode = objStopService.StopService()
		if (ReturnCode == 0) {
			ServiceUpdate();
		}
		WScript.Echo(" : " + ReturnCode)
	}
};

//      
function ServiceRun(Sender){
var cur_service_name, objRunService
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		objRunService = objWMIService.Get("Win32_Service.Name=\'" + cur_service_name + "\'");
		ReturnCode = objRunService.StartService()
		if (ReturnCode == 0) {
			ServiceUpdate();
		}
		WScript.Echo(" : " + ReturnCode)
	}
};

//      
function ServicePause(Sender){
var cur_service_name, objPauseService
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		objPauseService = objWMIService.Get("Win32_Service.Name=\'" + cur_service_name + "\'");
		ReturnCode = objPauseService.PauseService()
		if (ReturnCode == 0) {
			ServiceUpdate();
		}
		WScript.Echo(" : " + ReturnCode)
	}
};

//      
function ServiceContinue(Sender){
var cur_service_name, objResumeService
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		objResumeService = objWMIService.Get("Win32_Service.Name=\'" + cur_service_name + "\'");
		ReturnCode = objResumeService.ResumeService()
		if (ReturnCode == 0) {
			ServiceUpdate();
		}
		WScript.Echo(" : " + ReturnCode)
	}
};

//     
function ServiceAuto(Sender){
var cur_service_name, cur_service_state
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		cur_service_state = shared_data_array[list_view_obj.ItemIndex].State
		WshShell.Run ("cmd.exe /c sc config " + cur_service_name + " start= Auto" + " > " + temp_file,1,true);
		open_temp_file()
		ServiceUpdate()
	}
};

//     
function ServiceManual(Sender){
var cur_service_name, cur_service_state
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		cur_service_state = shared_data_array[list_view_obj.ItemIndex].State
		WshShell.Run ("cmd.exe /c sc config " + cur_service_name + " start= Demand" + " > " + temp_file,1,true);
		open_temp_file()
		ServiceUpdate()
	}
};

//  
function ServiceDisable(Sender){
var cur_service_name, cur_service_state
	//   
	if (list_view_obj.ItemIndex<0){
		WScript.Echo ("   ");
	//  
	}else if (ServiceDialog() == 1){
		cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name;
		cur_service_state = shared_data_array[list_view_obj.ItemIndex].State
		WshShell.Run ("cmd.exe /c sc config " + cur_service_name + " start= Disabled" + " > " + temp_file,1,true);
		open_temp_file()
		ServiceUpdate()
	}
};

//*****************************************************************

//   
function ServiceDialog(Sender){
var cur_service_name, Msg, Title, result;
	cur_service_name = shared_data_array[list_view_obj.ItemIndex].Name
	Msg = " ,      " + cur_service_name + " ?";
	Title = ",       ";
	result = WshShell.Popup(Msg,0,Title, vbOKCancel + vbInformation);
	//   ,    
	if (result == vbOK) {    
		return 1;
	}else{
		return 0;
	}
};

//   
function open_temp_file(){
var get_file_data, data_file
	get_file_data=FSO.OpenTextFile(temp_file, 1, false)
	data_file = get_file_data.ReadAll()
	get_file_data.Close()
	WshShell.Run ("wordpad.exe " + temp_file);
}

//    
CreateListView();

f.Show();
WSO.Run();